Merge branch 'master' into no-cache
[monkeysphere.git] / src / common
old mode 100755 (executable)
new mode 100644 (file)
index 8643080..64d28cb
@@ -1,21 +1,21 @@
 # -*-shell-script-*-
 
-# Shared bash functions for the monkeysphere
+# Shared sh functions for the monkeysphere
 #
 # Written by
 # Jameson Rollins <jrollins@fifthhorseman.net>
 #
 # Copyright 2008, released under the GPL, version 3 or later
 
-# all caps variables are meant to be user supplied (ie. from config
+# all-caps variables are meant to be user supplied (ie. from config
 # file) and are considered global
 
 ########################################################################
 # managed directories
 ETC="/etc/monkeysphere"
 export ETC
-LIB="/var/lib/monkeysphere"
-export LIB 
+CACHE="/var/cache/monkeysphere"
+export CACHE
 ########################################################################
 
 failure() {
@@ -23,14 +23,8 @@ failure() {
     exit ${2:-'1'}
 }
 
-# write output to stdout
-log() {
-    echo -n "ms: "
-    echo "$@"
-}
-
 # write output to stderr
-loge() {
+log() {
     echo -n "ms: " 1>&2
     echo "$@" 1>&2
 }
@@ -48,13 +42,23 @@ cutline() {
 # retrieve all keys with given user id from keyserver
 # FIXME: need to figure out how to retrieve all matching keys
 # (not just first 5)
-gpg_fetch_keys() {
-    local id
-    id="$1"
+gpg_fetch_userid() {
+    local userID
+
+    userID="$1"
+
+    log "checking keyserver $KEYSERVER..."
     echo 1,2,3,4,5 | \
        gpg --quiet --batch --command-fd 0 --with-colons \
        --keyserver "$KEYSERVER" \
-       --search ="$id" >/dev/null 2>&1
+       --search ="$userID" >/dev/null 2>&1
+    if [ "$?" = 0 ] ; then
+       log "  user ID found on keyserver."
+       return 0
+    else
+       log "  user ID not found on keyserver."
+       return 1
+    fi
 }
 
 # check that characters are in a string (in an AND fashion).
@@ -75,6 +79,18 @@ check_capability() {
     return 0
 }
 
+# get the full fingerprint of a key ID
+get_key_fingerprint() {
+    local keyID
+
+    keyID="$1"
+
+    gpg --list-key --with-colons --fixed-list-mode \
+       --with-fingerprint "$keyID" | grep "$keyID" | \
+       grep '^fpr:' | cut -d: -f10
+}
+
+
 # convert escaped characters from gpg output back into original
 # character
 # FIXME: undo all escape character translation in with-colons gpg output
@@ -82,219 +98,371 @@ unescape() {
     echo "$1" | sed 's/\\x3a/:/'
 }
 
-# stand in until we get dkg's gpg2ssh program
-gpg2ssh_tmp() {
+# convert key from gpg to ssh known_hosts format
+gpg2known_hosts() {
     local keyID
-    local userID
     local host
 
-    keyID="$2"
-    userID="$3"
-
-    if [ "$mode" = 'authorized_keys' ] ; then
-       gpgkey2ssh "$keyID" | sed -e "s/COMMENT/${userID}/"
+    keyID="$1"
+    host=$(echo "$2" | sed -e "s|ssh://||")
 
     # NOTE: it seems that ssh-keygen -R removes all comment fields from
     # all lines in the known_hosts file.  why?
     # NOTE: just in case, the COMMENT can be matched with the
     # following regexp:
     # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
-    elif [ "$MODE" = 'known_hosts' ] ; then
-       host=$(echo "$userID" | sed -e "s|ssh://||")
-       echo -n "$host "; gpgkey2ssh "$keyID" | sed -e "s/COMMENT/MonkeySphere${DATE}/"
-    fi
+    echo -n "$host "
+    gpg --export "$keyID" | \
+       openpgp2ssh "$keyID" | tr -d '\n'
+    echo " MonkeySphere${DATE}"
+}
+
+# convert key from gpg to ssh authorized_keys format
+gpg2authorized_keys() {
+    local keyID
+    local userID
+
+    keyID="$1"
+    userID="$2"
+
+    gpg --export "$keyID" | \
+       openpgp2ssh "$keyID" | tr -d '\n'
+    echo " MonkeySphere${DATE}: ${userID}"
 }
 
 # userid and key policy checking
 # the following checks policy on the returned keys
 # - checks that full key has appropriate valididy (u|f)
-# - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
+# - checks key has specified capability (REQUIRED_*_KEY_CAPABILITY)
 # - checks that particular desired user id has appropriate validity
 # see /usr/share/doc/gnupg/DETAILS.gz
 # expects global variable: "MODE"
 process_user_id() {
     local userID
     local cacheDir
+    local requiredCapability
     local requiredPubCapability
     local gpgOut
+    local userIDHash
+    local keyCacheDir
     local line
     local type
     local validity
     local keyid
     local uidfpr
-    local capability
+    local usage
     local keyOK
     local pubKeyID
     local uidOK
     local keyIDs
-    local userIDHash
     local keyID
 
     userID="$1"
     cacheDir="$2"
 
-    requiredPubCapability=$(echo "$REQUIRED_KEY_CAPABILITY" | tr "[:lower:]" "[:upper:]")
+    # set the required key capability based on the mode
+    if [ "$MODE" = 'known_hosts' ] ; then
+       requiredCapability="$REQUIRED_HOST_KEY_CAPABILITY"
+    elif [ "$MODE" = 'authorized_keys' ] ; then
+       requiredCapability="$REQUIRED_USER_KEY_CAPABILITY"      
+    fi
+    requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
 
-    # fetch keys from keyserver, return 1 if none found
-    gpg_fetch_keys "$userID" || return 1
+    # if CHECK_KEYSERVER variable set, check the keyserver
+    # for the user ID
+    if [ "$CHECK_KEYSERVER" = "true" ] ; then
+       gpg_fetch_userid "$userID"
+    fi
 
     # output gpg info for (exact) userid and store
-    gpgOut=$(gpg --fixed-list-mode --list-key --with-colons \
-       ="$userID" 2> /dev/null)
-
-    # return 1 if there only "tru" lines are output from gpg
-    if [ -z "$(echo "$gpgOut" | grep -v '^tru:')" ] ; then
-       loge "  key not found."
-       return 1
+    gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
+       --with-fingerprint --with-fingerprint \
+       ="$userID" 2>/dev/null)
+
+    # if the gpg query return code is not 0, return 1
+    if [ "$?" -ne 0 ] ; then
+        log "  key not found."
+        return 1
     fi
 
+    echo "$gpgOut"
+
     # loop over all lines in the gpg output and process.
     # need to do it this way (as opposed to "while read...") so that
     # variables set in loop will be visible outside of loop
-    for line in $(seq 1 $(echo "$gpgOut" | wc -l)) ; do
-
-       # read the contents of the line
-       type=$(echo "$gpgOut" | cutline "$line" | cut -d: -f1)
-       validity=$(echo "$gpgOut" | cutline "$line" | cut -d: -f2)
-       keyid=$(echo "$gpgOut" | cutline "$line" | cut -d: -f5)
-       uidfpr=$(echo "$gpgOut" | cutline "$line" | cut -d: -f10)
-       capability=$(echo "$gpgOut" | cutline "$line" | cut -d: -f12)
-
+    echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
+    while IFS=: read -r type validity keyid uidfpr usage ; do
        # process based on record type
        case $type in
            'pub') # primary keys
                # new key, wipe the slate
                keyOK=
-               pubKeyID=
                uidOK=
-               keyIDs=
-
-               pubKeyID="$keyid"
+               pubKeyOK=
+               fingerprint=
 
-               # check primary key validity
+               # if overall key is not valid, skip
                if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
-                   loge "  unacceptable primary key validity ($validity)."
+                   log "  unacceptable primary key validity ($validity)."
                    continue
                fi
-               # check capability is not Disabled...
-               if check_capability "$capability" 'D' ; then
-                   loge "  key disabled."
+               # if overall key is disabled, skip
+               if check_capability "$usage" 'D' ; then
+                   log "  key disabled."
                    continue
                fi
-               # check overall key capability
-               # must be Encryption and Authentication
-               if ! check_capability "$capability" $requiredPubCapability ; then
-                   loge "  unacceptable primary key capability ($capability)."
+               # if overall key capability is not ok, skip
+               if ! check_capability "$usage" $requiredPubCapability ; then
+                   log "  unacceptable primary key capability ($usage)."
                    continue
                fi
 
-               # mark if primary key is acceptable
+               # mark overall key as ok
                keyOK=true
 
-               # add primary key ID to key list if it has required capability
-               if check_capability "$capability" $REQUIRED_KEY_CAPABILITY ; then
-                   keyIDs[${#keyIDs[*]}]="$keyid"
+               # mark primary key as ok if capability is ok
+               if check_capability "$usage" $requiredCapability ; then
+                   pubKeyOK=true
                fi
                ;;
            'uid') # user ids
-               # check key ok and we have key fingerprint
+               # if the overall key is not ok, skip
                if [ -z "$keyOK" ] ; then
                    continue
                fi
-               # check key validity
-               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
+               # if an acceptable user ID was already found, skip
+               if [ "$uidOK" ] ; then
                    continue
                fi
-               # check the uid matches
+               # if the user ID does not match, skip
                if [ "$(unescape "$uidfpr")" != "$userID" ] ; then
                    continue
                fi
+               # if the user ID validity is not ok, skip
+               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
+                   continue
+               fi
 
-               # mark if uid acceptable
+               # mark user ID acceptable
                uidOK=true
+
+               # output a line for the primary key
+               # 0 = ok, 1 = bad
+               if [ "$keyOK" -a "$uidOK" -a "$pubKeyOK" ] ; then
+                   log "  acceptable key found"
+                   echo 0 "$fingerprint"
+               else
+                   echo 1 "$fingerprint"
+               fi
                ;;
            'sub') # sub keys
-               # add sub key ID to key list if it has required capability
-               if check_capability "$capability" $REQUIRED_KEY_CAPABILITY ; then
-                   keyIDs[${#keyIDs[*]}]="$keyid"
+               # unset acceptability of last key
+               subKeyOK=
+               fingerprint=
+
+               # if the overall key is not ok, skip
+               if [ -z "$keyOK" ] ; then
+                   continue
+               fi
+               # if sub key validity is not ok, skip
+               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
+                   continue
+               fi
+               # if sub key capability is not ok, skip
+               if ! check_capability "$usage" $requiredCapability ; then
+                   continue
+               fi
+
+               # mark sub key as ok
+               subKeyOK=true
+               ;;
+           'fpr') # key fingerprint
+               fingerprint="$uidfpr"
+
+               # output a line for the last subkey
+               # 0 = ok, 1 = bad
+               if [ "$keyOK" -a "$uidOK" -a "$subKeyOK" ] ; then
+                   log "  acceptable key found"
+                   echo 0 "$fingerprint"
+               else
+                   echo 1 "$fingerprint"
                fi
                ;;
        esac
     done
+}
 
-    # hash userid for cache file name
-    userIDHash=$(echo "$userID" | sha1sum | awk '{ print $1 }')
-
-    # touch/clear key cache file
-    # (will be left empty if there are noacceptable keys)
-    > "$cacheDir"/"$userIDHash"."$pubKeyID"
-
-    # for each acceptable key, write an ssh key line to the
-    # key cache file
-    if [ "$keyOK" -a "$uidOK" -a "${keyIDs[*]}" ] ; then
-       for keyID in ${keyIDs[@]} ; do
-           loge "  acceptable key/uid found."
-
-           # export the key with gpg2ssh
-            # FIXME: needs to apply extra options for authorized_keys
-           # lines if specified
-           gpg2ssh_tmp "$keyID" "$userID" >> "$cacheDir"/"$userIDHash"."$pubKeyID"
-
-           # hash the cache file if specified
-           if [ "$MODE" = 'known_hosts' -a "$HASH_KNOWN_HOSTS" ] ; then
-               ssh-keygen -H -f "$cacheDir"/"$userIDHash"."$pubKeyID" > /dev/null 2>&1
-               rm "$cacheDir"/"$userIDHash"."$pubKeyID".old
-           fi
-       done
+# update the cache for userid, and prompt to add file to
+# authorized_user_ids file if the userid is found in gpg
+# and not already in file.
+update_userid() {
+    local userID
+    local cacheDir
+    local keyCache
+
+    userID="$1"
+    cacheDir="$2"
+
+    log "processing userid: '$userID'"
+
+    # return 1 if there is no output of the user ID processing
+    # ie. no key was found
+    keyCachePath=$(process_user_id "$userID" "$cacheDir")
+    if [ -z "$keyCachePath" ] ; then
+       return 1
     fi
 
-    # echo the path to the key cache file
-    echo "$cacheDir"/"$userIDHash"."$pubKeyID"
+    # check if user ID is in the authorized_user_ids file
+    if ! grep -q "^${userID}\$" "$AUTHORIZED_USER_IDS" ; then
+       read -p "user ID not currently authorized.  authorize? [Y|n]: " OK; OK=${OK:=Y}
+       if [ ${OK/y/Y} = 'Y' ] ; then
+           # add if specified
+           log -n "adding user ID to authorized_user_ids file... "
+           echo "$userID" >> "$AUTHORIZED_USER_IDS"
+           echo "done."
+       else
+           # else do nothing
+           log "authorized_user_ids file untouched."
+       fi
+    fi
+}
+
+# remove a userid from the authorized_user_ids file
+remove_userid() {
+    local userID
+
+    userID="$1"
+
+    log "processing userid: '$userID'"
+
+    # check if user ID is in the authorized_user_ids file
+    if ! grep -q "^${userID}\$" "$AUTHORIZED_USER_IDS" ; then
+       log "user ID not currently authorized."
+       return 1
+    fi
+
+    # remove user ID from file
+    log -n "removing user ID '$userID'... "
+    grep -v "$userID" "$AUTHORIZED_USER_IDS" | sponge "$AUTHORIZED_USER_IDS"
+    echo "done."
+}
+
+# remove all keys from specified key cache from known_hosts file
+remove_known_hosts_host_keys() {
+    local keyCachePath
+    local hosts
+    local type
+    local key
+    local comment
+
+    keyCachePath="$1"
+
+    meat "${keyCachePath}/keys" | \
+    while read -r hosts type key comment ; do
+       grep -v "$key" "$USER_KNOWN_HOSTS" | sponge "$USER_KNOWN_HOSTS"
+    done
 }
 
 # process a host for addition to a known_host file
 process_host() {
     local host
     local cacheDir
-    local hostKeyCachePath
+    local keyCachePath
 
     host="$1"
     cacheDir="$2"
 
-    log "processing host: '$host'"
-
-    hostKeyCachePath=$(process_user_id "ssh://${host}" "$cacheDir")
-    if [ $? = 0 ] ; then
-       ssh-keygen -R "$host" -f "$USER_KNOWN_HOSTS"
-       cat "$hostKeyCachePath" >> "$USER_KNOWN_HOSTS"
-    fi
+    log "processing host: $host"
+
+    userID="ssh://${host}"
+    process_user_id "ssh://${host}"
+    exit
+    process_user_id "ssh://${host}" | \
+    while read -r ok key ; do
+       # remove the old host key line
+       remove_known_hosts_host_keys "$key"
+       # if key OK, add new host line
+       if [ "$ok" -eq '0' ] ; then
+           known_hosts_line "$host" "$key" >> "$USER_KNOWN_HOSTS"
+       fi
+    done
 }
 
 # process known_hosts file
 # go through line-by-line, extract each host, and process with the
 # host processing function
 process_known_hosts() {
-    local knownHosts
     local cacheDir
     local hosts
     local host
 
-    knownHosts="$1"
-    cacheDir="$2"
+    cacheDir="$1"
 
     # take all the hosts from the known_hosts file (first field),
-    # grep out all the hashed hosts (lines starting with '|')
-    cut -d ' ' -f 1 "$knownHosts" | \
-    grep -v '^|.*$' | \
+    # grep out all the hashed hosts (lines starting with '|')...
+    meat "$USER_KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | \
     while IFS=, read -r -a hosts ; do
-       # process each host
+       # ...and process each host
        for host in ${hosts[*]} ; do
            process_host "$host" "$cacheDir"
        done
     done
 }
 
-# process authorized_keys file
+# update an authorized_keys file after first processing the 
+# authorized_user_ids file
+update_authorized_keys() {
+    local msAuthorizedKeys
+    local userAuthorizedKeys
+    local cacheDir
+
+    msAuthorizedKeys="$1"
+    userAuthorizedKeys="$2"
+    cacheDir="$3"
+
+    process_authorized_ids "$AUTHORIZED_USER_IDS" "$cacheDir"
+
+    # write output key file
+    log "writing monkeysphere authorized_keys file... "
+    touch "$msAuthorizedKeys"
+    if [ "$(ls "$cacheDir")" ] ; then
+       log -n "adding gpg keys... "
+       cat "$cacheDir"/* > "$msAuthorizedKeys"
+       echo "done."
+    else
+       log "no gpg keys to add."
+    fi
+    if [ "$userAuthorizedKeys" != "-" -a -s "$userAuthorizedKeys" ] ; then
+       log -n "adding user authorized_keys file... "
+       cat "$userAuthorizedKeys" >> "$msAuthorizedKeys"
+       echo "done."
+    fi
+    log "monkeysphere authorized_keys file generated:"
+    log "$msAuthorizedKeys"
+}
+
+# process an authorized_*_ids file
+# go through line-by-line, extract each userid, and process
+process_authorized_ids() {
+    local authorizedIDs
+    local cacheDir
+    local userID
+
+    authorizedIDs="$1"
+    cacheDir="$2"
+
+    process_user_id "$userID" | \
+    while read -r ok key ; do
+       # remove the old host key line
+       remove_authorized_keys_user_keys "$key"
+       # if key OK, add new host line
+       if [ "$ok" -eq '0' ] ; then
+           authorized_keys_line "$userID" "$key" >> "$USER_AUTHORIZED_KEYS"
+       fi
+    done
+}
+
+# EXPERIMENTAL (unused) process userids found in authorized_keys file
 # go through line-by-line, extract monkeysphere userids from comment
 # fields, and process each userid
 process_authorized_keys() {
@@ -328,26 +496,43 @@ process_authorized_keys() {
     done
 }
 
-# process an authorized_*_ids file
-# go through line-by-line, extract each userid, and process
-process_authorized_ids() {
-    local authorizedIDs
-    local cacheDir
-    local userID
+# retrieve key from web of trust, and set owner trust to "full"
+# if key is found.
+trust_key() {
+    # get the key from the key server
+    if ! gpg --keyserver "$KEYSERVER" --recv-key "$keyID" ; then
+       log "could not retrieve key '$keyID'"
+       return 1
+    fi
 
-    authorizedIDs="$1"
-    cacheDir="$2"
+    # get key fingerprint
+    fingerprint=$(get_key_fingerprint "$keyID")
 
-    # clean out keys file and remake keys directory
-    rm -rf "$cacheDir"
-    mkdir -p "$cacheDir"
+    # attach a "non-exportable" signature to the key
+    # this is required for the key to have any validity at all
+    # the 'y's on stdin indicates "yes, i really want to sign"
+    echo -e 'y\ny' | gpg --lsign-key --command-fd 0 "$fingerprint"
 
-    # loop through all user ids in file
-    # FIXME: needs to handle authorized_keys options
-    cat "$authorizedIDs" | meat | \
-    while read -r userID ; do
-       # process the userid
-       log "processing userid: '$userID'"
-       process_user_id "$userID" "$cacheDir" > /dev/null
-    done
+    # import "full" trust for fingerprint into gpg
+    echo ${fingerprint}:5: | gpg --import-ownertrust
+    if [ $? = 0 ] ; then
+       log "owner trust updated."
+    else
+       failure "there was a problem changing owner trust."
+    fi 
+}
+
+# publish server key to keyserver
+publish_server_key() {
+    read -p "really publish key to $KEYSERVER? [y|N]: " OK; OK=${OK:=N}
+    if [ ${OK/y/Y} != 'Y' ] ; then
+       failure "aborting."
+    fi
+
+    # publish host key
+    # FIXME: need to figure out better way to identify host key
+    # dummy command so as not to publish fakes keys during testing
+    # eventually:
+    #gpg --send-keys --keyserver "$KEYSERVER" $(hostname -f)
+    echo "NOT PUBLISHED: gpg --send-keys --keyserver $KEYSERVER $(hostname -f)"
 }